/***********************************************************************\
* vov is a tool that emulates the behavior of a Von-Neumann machine.    *
* Copyright (C) 2001-2008 Davide Scola <davide.scola@gmail.com>         *
*                                                                       *
* This file is part of vov.                                             *
*                                                                       *
* vov is free software; you can  redistribute it and/or modify it under *
* the terms of the GNU General  Public License as published by the Free *
* Software Foundation;  either version  2 of the  License, or  (at your *
* option) any later version.                                            *
*                                                                       *
* vov is  distributed in the hope  that it will be  useful, but WITHOUT *
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or *
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License *
* for more details.                                                     *
*                                                                       *
* You should  have received a  copy of  the GNU General  Public License *
* along  with vov;  if  not,  write to  the  Free Software  Foundation, *
* Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.    *
\***********************************************************************/

#ifndef _LINE_H
#define _LINE_H

/*
 * clean line 
 */
#ifdef line_cleanup
# undef line_cleanup
#endif

#define line_cleanup(ln) \
do { \
  if (NULL != (ln).s) \
    free((ln).s); \
  (ln).s = NULL; \
} \
while(0)


/*
 * line 
 */
struct line {
    char           *s;		/* line buffer */
    unsigned long int len;	/* line lenght */
    unsigned long int a;	/* actual allocated size */
};

typedef struct line line_t;


#ifdef __cplusplus
extern          "C" {
#endif				/* __cplusplus */

    int             safe_grows_line(line_t *, unsigned long);
    int             line_tail(line_t *, const char *);

#ifdef __cplusplus
}
#endif				/* __cplusplus */
#endif				/* _LINE_H */
