/***********************************************************************\
* vov is a tool that emulates the behavior of a Von-Neumann machine.    *
* Copyright (C) 2001-2008 Davide Scola <davide.scola@gmail.com>         *
*                                                                       *
* This file is part of vov.                                             *
*                                                                       *
* vov is free software; you can  redistribute it and/or modify it under *
* the terms of the GNU General  Public License as published by the Free *
* Software Foundation;  either version  2 of the  License, or  (at your *
* option) any later version.                                            *
*                                                                       *
* vov is  distributed in the hope  that it will be  useful, but WITHOUT *
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or *
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License *
* for more details.                                                     *
*                                                                       *
* You should  have received a  copy of  the GNU General  Public License *
* along  with vov;  if  not,  write to  the  Free Software  Foundation, *
* Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.    *
\***********************************************************************/

#ifndef _OPTIONS_H
#define _OPTIONS_H

/*
 * default memory and cpu limit (if supported) 
 */
#ifdef HAVE_CHANGE_LIMIT
# ifdef DEF_MEM_LMT
#  undef DEF_MEM_LMT
# endif

# define DEF_MEM_LMT		(2000000UL)

# ifdef DEF_CPU_LMT
#  undef DEF_CPU_LMT
# endif

# define DEF_CPU_LMT		(2UL)
#endif

/*
 * set given option 
 */
#ifdef OPTION_SETS
# undef OPTION_SETS
#endif

#define OPTION_SETS(x)		((options) |= (x))


/*
 * unset given option 
 */
#ifdef OPTION_DOWN
# undef OPTION_DOWN
#endif

#define OPTION_DOWN(x)          ((options) &= ~(x))


/*
 * test given option 
 */
#ifdef OPTION_TEST
# undef OPTION_TEST
#endif

#define OPTION_TEST(x)          ((options) & (x))


/*
 * options list 
 */
enum {
    VERBOSE = 01,		/* be verbose */
#define VERBOSE			VERBOSE
    IACTIVE = 02,		/* be interactive */
#define IACTIVE			IACTIVE
    BEQUIET = 04		/* be quiet */
#define BEQUIET			BEQUIET
};


/*
 * used by version function 
 */
enum {
    EXIT_NOW0 = 00,		/* exit now */
#define EXIT_NOW		EXIT_NOW
    DONT_EXIT = -1		/* do not exit */
#define DONT_EXIT		DONT_EXIT
};



#ifdef __cplusplus
extern          "C" {
#endif				/* __cplusplus */

    void            parse_cmdline(int *, char ***);
    void            version(int);

#ifdef __cplusplus
}
#endif				/* __cplusplus */
#endif				/* _OPTIONS_H */
