/***********************************************************************\
* vov is a tool that emulates the behavior of a Von-Neumann machine.    *
* Copyright (C) 2001-2008 Davide Scola <davide.scola@gmail.com>         *
*                                                                       *
* This file is part of vov.                                             *
*                                                                       *
* vov is free software; you can  redistribute it and/or modify it under *
* the terms of the GNU General  Public License as published by the Free *
* Software Foundation;  either version  2 of the  License, or  (at your *
* option) any later version.                                            *
*                                                                       *
* vov is  distributed in the hope  that it will be  useful, but WITHOUT *
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or *
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License *
* for more details.                                                     *
*                                                                       *
* You should  have received a  copy of  the GNU General  Public License *
* along  with vov;  if  not,  write to  the  Free Software  Foundation, *
* Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.    *
\***********************************************************************/

#ifndef _SCANNER_H
#define _SCANNER_H

/*
 * type of yylval 
 */
#ifdef YYSTYPE
# undef YYSTYPE
#endif

#define YYSTYPE unsigned long int


/*
 * re-define yy_fatal_error routine 
 */
#ifdef YY_FATAL_ERROR
# undef YY_FATAL_ERROR
#endif

#define YY_FATAL_ERROR(x)	my_fatal_error(x)


/*
 * we don't need yyunput 
 */
#ifdef YY_NO_UNPUT
# undef YY_NO_UNPUT
#endif

#define YY_NO_UNPUT		1


#ifdef __cplusplus
extern          "C" {
#endif				/* __cplusplus */

    void            yyerror(const char[]);
    int             yylex(void);
    int             load_external_program(const char *);

#ifdef __cplusplus
}
#endif				/* __cplusplus */
#endif				/* _SCANNER_H */
