/***********************************************************************\
* vov is a tool that emulates the behavior of a Von-Neumann machine.    *
* Copyright (C) 2001-2008 Davide Scola <davide.scola@gmail.com>         *
*                                                                       *
* This file is part of vov.                                             *
*                                                                       *
* vov is free software; you can  redistribute it and/or modify it under *
* the terms of the GNU General  Public License as published by the Free *
* Software Foundation;  either version  2 of the  License, or  (at your *
* option) any later version.                                            *
*                                                                       *
* vov is  distributed in the hope  that it will be  useful, but WITHOUT *
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or *
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License *
* for more details.                                                     *
*                                                                       *
* You should  have received a  copy of  the GNU General  Public License *
* along  with vov;  if  not,  write to  the  Free Software  Foundation, *
* Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.    *
\***********************************************************************/

#ifndef _SYM_TABLE_H
#define _SYM_TABLE_H

/*
 * a little shortcut to declare a symbol 
 */
#ifdef CPU_SYMBOL
# undef CPU_SYMBOL
#endif

#define CPU_SYMBOL(x)   void x (void)

/*
 * some system details used by (over|under)flows checks 
 */
#undef GREATER_SIGNED

#if INT32_MAX == UINT32_MAX
#  define GREATER_SIGNED        1
#else
#  define GREATER_SIGNED        0
#endif

#undef GREATER_NEGATIVE

#if INT32_MIN < -INT32_MAX
# define GREATER_NEGATIVE      1
#else
# define GREATER_NEGATIVE      0
#endif


/*
 * return types of catch_bug functions 
 */
enum {
    NFLOW = 0,			/* normalflow */
#define NFLOW			NFLOW
    UFLOW = 1,			/* underflow */
#define UFLOW                   UFLOW
    OFLOW = 2			/* overflow */
#define OFLOW			OFLOW
};


#ifdef __cplusplus
extern          "C" {
#endif				/* __cplusplus */

    CPU_SYMBOL(vov_add);
    CPU_SYMBOL(vov_sub);
    CPU_SYMBOL(vov_read);
    CPU_SYMBOL(vov_write);
    CPU_SYMBOL(vov_store);
    CPU_SYMBOL(vov_load);
    CPU_SYMBOL(vov_jmp);
    CPU_SYMBOL(vov_jzero);
    CPU_SYMBOL(vov_halt);

#ifdef __cplusplus
}
#endif				/* __cplusplus */
#endif				/* _SYM_TABLE_H */
