/***********************************************************************\
* vov is a tool that emulates the behavior of a Von-Neumann machine.    *
* Copyright (C) 2001-2008 Davide Scola <davide.scola@gmail.com>         *
*                                                                       *
* This file is part of vov.                                             *
*                                                                       *
* vov is free software; you can  redistribute it and/or modify it under *
* the terms of the GNU General  Public License as published by the Free *
* Software Foundation;  either version  2 of the  License, or  (at your *
* option) any later version.                                            *
*                                                                       *
* vov is  distributed in the hope  that it will be  useful, but WITHOUT *
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or *
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License *
* for more details.                                                     *
*                                                                       *
* You should  have received a  copy of  the GNU General  Public License *
* along  with vov;  if  not,  write to  the  Free Software  Foundation, *
* Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.    *
\***********************************************************************/

#ifndef _UTILS_H
#define _UTILS_H

/*
 * size of a string that holds an unsigned long 
 */
#ifdef FMT_ULONG
# undef FMT_ULONG
#endif

#define FMT_ULONG               (40)	/* enough space to hold 2^128 - 1
					 * in decimal, plus \0 */


#ifdef __cplusplus
extern          "C" {
#endif				/* __cplusplus */

    unsigned int    stringify(register char *, register long int);
    void            ulongify(const char *, unsigned long int *);
    void            longify(const char *src, long *dest);
    unsigned long   byte_chr(const void *, unsigned long, char);
    void            byte_copy(void *, unsigned long, const void *);
    unsigned long   str_len(const char *);
#ifdef HAVE_CHANGE_LIMIT
    void            limit_memory(unsigned long);
    void            limit_cpu(unsigned long);
#endif

#ifdef __cplusplus
}
#endif				/* __cplusplus */
#endif				/* _UTILS_H */
