dnl @synopsis AC_CHECK_UTILS([TOOL, ...] [, ACTIONS-IF-FOUND] [, ACTIONS-IF-NOT-FOUND])
dnl
dnl Checks, for  any argument of the  TOOL-LIST, if it is  present on some
dnl common paths and  sets a variable, usable in your  Makefiles, named as
dnl the  tool itself  but  in uppercase  letters (i.e.  tex  will be  TEX)
dnl containing the  full path of the  tool if found, 'no'  otherwise.  You
dnl can also set any user defined action that will be run accordingly.
dnl
dnl Examples:
dnl    AC_CHECK_UTILS([bar], [AM_CONDITIONAL(FOO, true)],[AM_CONDITIONAL(FOO, false)])
dnl
dnl    AC_CHECK_UTILS([bar], [AM_CONDITIONAL(FOOBAR, true)])
dnl
dnl    AC_CHECK_UTILS([foo bar])
dnl
dnl @category Misc
dnl @author Davide Scola <davide.scola@gmail.com>
dnl @version 2005-02-08
dnl @license AllPermissive


AC_DEFUN([AC_CHECK_UTIL],
[
  AS_LITERAL_IF([$1], [], [AC_FATAL([$0: requires literal arguments])])

  AS_VAR_PUSHDEF([ac_Util], translit([$1], [a-z], [A-Z]))

  dnl add /usr/share/texmf/bin for slackware support
  AC_PATH_PROG([]ac_Util, $1, no, /usr/local/bin:/usr/bin:/bin:/usr/share/texmf/bin)

  AS_IF([test AS_VAR_GET(ac_Util) != no], [$2], [$3])
  AS_VAR_POPDEF([ac_Util])
])# AC_CHECK_UTIL


AC_DEFUN([AC_CHECK_UTILS],
[
  m4_foreach([AC_Util], [$1],
             [
               AC_CHECK_UTIL(AC_Util, [$2], [$3])
             ])
])
